﻿Type=Activity
Version=3
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

#Region "Views"
	Dim btnCrea As Button
	Dim btnEsci As Button
	Dim edtBkpName As EditText
	Dim edtNote As EditText
	Dim lblBkpName As Label
	Dim lblNote As Label
	Dim lblDestinationLBL As Label
	Dim lblDestFolder As Label
	Dim lsvBkpNames As ListView
	Dim rbCreate As RadioButton
	Dim rbRestore As RadioButton
	Dim chkAutoONOFF As CheckBox
	Dim spnPeriod As Spinner
#End Region

	Dim IME1 As IME

	Private mBackup As clsSQLiteBackup
	Private mBkpDestFolder As String
	Private mMaxBackups As Int
End Sub


#Region Activity cicle

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	Activity.LoadLayout("layBackup")
	Activity.Title = "Backups"
	
	spnPeriod.Clear
	spnPeriod.Add("Daily")
	spnPeriod.Add("Weekly")
	spnPeriod.Add("Monthly")

	lblBkpName.Text = "Name"
	btnCrea.Text = "Creation"
	btnEsci.Text = "Exit"
	lblDestinationLBL.Text = "Backup Folder"
	rbCreate.Text = "Creation"
	rbRestore.Text = "Restore"
	chkAutoONOFF.Text = "OFF"

	lsvBkpNames.TwoLinesLayout.Label.Gravity = Gravity.TOP
	lsvBkpNames.TwoLinesLayout.Label.Typeface = Typeface.MONOSPACE
	lsvBkpNames.TwoLinesLayout.Label.TextSize = 14
	lsvBkpNames.TwoLinesLayout.Label.Height = 40dip
	lsvBkpNames.TwoLinesLayout.Label.TextColor = Colors.Yellow

	lsvBkpNames.TwoLinesLayout.SecondLabel.Top = lsvBkpNames.TwoLinesLayout.Label.Height
	lsvBkpNames.TwoLinesLayout.SecondLabel.TextSize = 14
	lsvBkpNames.TwoLinesLayout.SecondLabel.Height = 30dip
	lsvBkpNames.TwoLinesLayout.SecondLabel.TextColor = Colors.White

	lsvBkpNames.TwoLinesLayout.ItemHeight = 3dip + lsvBkpNames.TwoLinesLayout.Label.Height + lsvBkpNames.TwoLinesLayout.SecondLabel.Height

	Scale.ScaleAll(Activity, True)

	IME1.Initialize("IME1")
	IME1.AddHeightChangedEvent

End Sub

Sub Activity_Resume
	ReadPref
	lblDestFolder.Text = mBkpDestFolder
	If Not(mBackup.IsInitialized) Then
		mBackup.Initialize(Main.AppDir, Main.DB, Main.AppDir, Main.DBName, mBkpDestFolder, True, mMaxBackups)
	End If
	mBackup.FillListView(lsvBkpNames)
	
	mBackup.ReadSettings
	chkAutoONOFF.Checked = mBackup.Auto
	spnPeriod.SelectedIndex = Max(0, mBackup.AutoPeriod-1)
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

#End Region

Sub Activity_KeyPress(KeyCode As Int) As Boolean 'Return True to consume the event
	If KeyCode = KeyCodes.KEYCODE_BACK Then
		Return True ' annulla il back
	End If
	Return False
End Sub


#Region "Views Events"

Sub lblDestFolder_Click
	Dim FD As FileDialog
	FD.ShowOnlyFolders = True
	If FD.Show("Select the destination folder", "OK", "Cancel", "", Null) _ 
		= DialogResponse.POSITIVE Then
		lblDestFolder.Text = FD.FilePath
		mBkpDestFolder = FD.FilePath
		' Initializes the backup object
		mBackup.Initialize(Main.AppDir, Main.DB, Main.AppDir, Main.DBName, mBkpDestFolder, True, mMaxBackups)
		' Saves the destination path to preferences
		SavePref(mBkpDestFolder)
	End If
End Sub

Sub rbCreate_CheckedChange(Checked As Boolean)
	Handle_ModeSelection(Checked)
End Sub

Sub rbRestore_CheckedChange(Checked As Boolean)
	Handle_ModeSelection(Not(Checked))
End Sub

Sub btnCrea_Click
	btnCrea.Visible = False

	If Not(chkAutoONOFF.Checked) Then
	
		' Manual
	
		' Checks if the backup name entered exists.
		If mBackup.BackupExists(edtBkpName.Text) Then
			Msgbox(edtBkpName.Text & " backup already exists.", "")
		Else
			IME1.HideKeyboard
			If mBackup.CreateBackup(edtBkpName.Text, edtNote.text) Then
				ToastMessageShow("Backup " & edtBkpName.Text & " created", False)
				edtBkpName.Text = ""
				edtNote.Text = ""
				edtBkpName.RequestFocus
			Else
				Msgbox("Backup " & "failed", "")
			End If
		End If
		
	Else 
	
		' Automatic
		
		mBackup.AutoPeriod = spnPeriod.SelectedIndex + 1
		btnEsci_Click
	
	End If
	
End Sub

Sub lsvBkpNames_ItemClick (Position As Int, Value As Object)
	Dim Res As Int
	Dim BackupName As String = Value
	Res = Msgbox2("Restore " & BackupName & "?", "Restore", "Yes", "Cancel", "", Null)
	If Res = DialogResponse.POSITIVE Then
		If mBackup.RestoreFromBackup(BackupName) Then
			Msgbox("Restore completed.", "Restore")
		Else
			Msgbox("Restore failed.", "Restore")
		End If
	End If	
End Sub

Sub lsvBkpNames_ItemLongClick (Position As Int, Value As Object)
	Dim BackupName As String = Value
	Dim Res As Int = Msgbox2("Do you want to delete: " & BackupName & "?", "ATTENTION", "Yes", "", "No", Null)
	If Res = DialogResponse.POSITIVE Then
		lsvBkpNames.RemoveAt(Position)
		mBackup.DeleteBackup(BackupName)
		mBackup.SaveBackupMap
	End If	
End Sub

Sub edtBkpName_TextChanged (Old As String, New As String)
	btnCrea.Visible = (New.Length > 0 )
End Sub

Sub spnPeriod_ItemClick (Position As Int, Value As Object)
	
End Sub

Sub chkAutoONOFF_CheckedChange(Checked As Boolean)
	mBackup.Auto = Checked
	mBackup.SaveBackupMap

	lblBkpName.Visible = Not(Checked)
	edtBkpName.Visible = Not(Checked)
	lblNote.Visible = Not(Checked)
	edtNote.Visible = Not(Checked)
	btnCrea.Visible = Checked
	
	If Checked Then
		chkAutoONOFF.Text = "ON"
		btnCrea.Text = "OK"
	Else
		chkAutoONOFF.Text = "OFF"
		btnCrea.Text = "Create"
	End If
	
End Sub

Sub IME1_HeightChanged(NewHeight As Int, OldHeight As Int)
End Sub

Sub btnEsci_Click
	Activity.Finish	
End Sub

#End Region


#Region Private methods

Private Sub Handle_ModeSelection(SaveChecked As Boolean)
	lblBkpName.Visible = SaveChecked
	edtBkpName.Visible = SaveChecked
	lblNote.Visible = SaveChecked
	edtNote.Visible = SaveChecked
	chkAutoONOFF.Visible = SaveChecked
	spnPeriod.Visible = SaveChecked
	lsvBkpNames.Visible = Not(SaveChecked)
	
	If Not(SaveChecked) Then
		mBackup.FillListView(lsvBkpNames)
	End If
End Sub

#Region --- IO Backup

Private Sub LoadBackupMap
	mBackup.FillListView(lsvBkpNames)
End Sub

#End Region

Private Sub ReadPref
	mBkpDestFolder = Main.KVStore.GetSimple2("BkpDir", File.DirRootExternal)
	mMaxBackups = Main.KVStore.GetSimple2("MaxBackups", 5)
End Sub

Private Sub SavePref(DestFolder As String)
	Main.KVStore.PutSimple("BkpDir", DestFolder)
End Sub


#End Region